<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : Jan 24, 2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-01-06 13:30:38 +0100 (Fr, 06. Jan 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9203 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.frontend/application/modules/default/controllers/ErrorController.php $
 *
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/**
 */
require_once 'Hpls/Controller/Action.php';
require_once 'Hpls/Consts.php';

/**
 *
 * @todo comment
 *      
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *           
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9203 $
 * @since 1.0.9
 */
class ErrorController extends Hpls_Controller_Action {

	public function errorAction() {
		$this->_helper->layout->getLayoutInstance()->disableLayout();
		// $this->_helper->contextSwitch()->initContext();
		
		$errors = $this->_getParam('error_handler');
		
		switch ($errors->type) {
			case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ROUTE :
			case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER :
			case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION :
				
				// 404 error -- controller or action not found
				$this->getResponse()->setHttpResponseCode(404);
				$this->view->exception = $errors->exception;
				$this->log()->err(__METHOD__ . " caught exception: " . Hpls_Debug::print_r($errors->exception));
				$this->view->response = $this->getResponse();
				$this->view->request = $this->getRequest();
				$this->view->message = $errors->exception->getMessage();
				break;
			default :
				// application error
				$this->getResponse()->setHttpResponseCode(500);
				
				if (!empty($errors->exception)) {
					if ($errors->exception instanceof PDOException || $errors->exception instanceof Zend_Db_Exception) {
						Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'db', "Datenbankverbindung ist gescheitert.\n" . $errors->exception->getMessage(), $errors->exception->getCode(), null, true, true);
						$this->_redirect('mailtrace/config/logdatabase');
						
						return; // exit zum forwarded-controller
					}
					// Zend_Controller_Dispatcher_Exception
					$msg = get_class($errors->exception) . ': ' . $errors->exception->getMessage();
				} else {
					$msg = 'Application Error';
				}
				$this->view->message = $msg;
				break;
		}
		$message = $this->view->message;
		if (APPLICATION_ENV == Hpls_Consts::ENV_APP_DEV) {
			require_once 'Zend/Debug.php';
			$this->view->request = Zend_Debug::dump($errors->request, 'Request:', false);
			
			// $message .= "\nRequest:\n";
			// $message .= Zend_Debug::dump($this->getRequest(), false);
			// $message .=
		// "\nResponse:\n".Zend_Debug::dump($this->getResponse(), false);
		}
		
		// Log exception, if logger available
		if ($log = $this->getLog()) {
			$log->crit('Application ERROR: ' . $message . ":\n" . $errors->exception);
		}
		
		// conditionally display exceptions
		if ($this->getInvokeArg('displayExceptions') == true) {
			$this->view->exception = $errors->exception;
		}
	}

	public function getLog() {
		return Zend_Registry::get(Hpls_Consts::REGK_LOGGER);
	}

}

