SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Datenbank: `mailtrace_rules_vendor`
--

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `config`
--

CREATE TABLE IF NOT EXISTS `config` (
  `key` varchar(250) NOT NULL,
  `value` text,
  `time_created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `roles`
--

CREATE TABLE IF NOT EXISTS `roles` (
  `id` int(11) NOT NULL auto_increment,
  `role_name` varchar(50) NOT NULL,
  `time_created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL default '0000-00-00 00:00:00',
  `id_t` varchar(1) NOT NULL default 'v',
  `rule_id_t` varchar(1) NOT NULL default 'v',
  `inactive_state` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `unique_role_name` (`role_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `rule_ids`
--

CREATE TABLE IF NOT EXISTS `rule_ids` (
  `id` int(11) NOT NULL auto_increment,
  `rule_name` varchar(50) NOT NULL,
  `description` text NOT NULL,
  `time_created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL default '0000-00-00 00:00:00',
  `id_t` varchar(1) NOT NULL default 'v',
  `inactive_state` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `unique_rule_id` (`rule_name`),
  UNIQUE KEY `unique_rule_ids_id_t` (`id`,`id_t`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=22 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `regexrule`
--

CREATE TABLE IF NOT EXISTS `regexrule` (
  `id` int(11) NOT NULL auto_increment,
  `regex` varchar(1024) NOT NULL,
  `rule_id` int(11) NOT NULL,
  `deactivated` tinyint(4) NOT NULL,
  `description` text,
  `param_map` varchar(512) NOT NULL,
  `priority` int(11) NOT NULL default '0',
  `time_created` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL default '0000-00-00 00:00:00',
  `id_t` varchar(1) NOT NULL default 'v',
  `rule_id_t` varchar(1) NOT NULL default 'v',
  `inactive_state` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=28 ;