--
-- PostgreSQL database dump
--

-- Started on 2011-03-28 14:32:49 CEST

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1478 (class 1259 OID 54064)
-- Dependencies: 3
-- Name: config; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--

CREATE TABLE config (
  "key" character varying(1024) NOT NULL,
  "value" text,
  time_created timestamp with time zone NOT NULL DEFAULT now(),
  time_updated timestamp with time zone NOT NULL DEFAULT now(),
  inactive_state smallint NOT NULL DEFAULT 0
);


ALTER TABLE public.config OWNER TO mailtrace;

--
-- TOC entry 1484 (class 1259 OID 54097)
-- Dependencies: 1756 3
-- Name: regexrule; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--

CREATE TABLE regexrule (
  id integer NOT NULL,
  regex character varying(1024) NOT NULL,
  rule_id integer,
  rule_id_t character varying(1) NOT NULL DEFAULT 'v',
deactivated boolean,
  description text,
  param_map character varying(512),
  priority integer NOT NULL DEFAULT 0,
  time_created timestamp with time zone NOT NULL DEFAULT now(),
  time_updated timestamp with time zone NOT NULL DEFAULT now(),
  inactive_state smallint NOT NULL DEFAULT 0
);


ALTER TABLE public.regexrule OWNER TO mailtrace;

--
-- TOC entry 1483 (class 1259 OID 54095)
-- Dependencies: 1484 3
-- Name: regexrule_id_seq; Type: SEQUENCE; Schema: public; Owner: mailtrace
--

CREATE SEQUENCE regexrule_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.regexrule_id_seq OWNER TO mailtrace;

--
-- TOC entry 1791 (class 0 OID 0)
-- Dependencies: 1483
-- Name: regexrule_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: mailtrace
--

ALTER SEQUENCE regexrule_id_seq OWNED BY regexrule.id;


--
-- TOC entry 1792 (class 0 OID 0)
-- Dependencies: 1483
-- Name: regexrule_id_seq; Type: SEQUENCE SET; Schema: public; Owner: mailtrace
--

SELECT pg_catalog.setval('regexrule_id_seq', 8, true);


--
-- TOC entry 1480 (class 1259 OID 54074)
-- Dependencies: 3
-- Name: roles; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--

CREATE TABLE roles (
  id integer NOT NULL,
  role_name character varying(50) NOT NULL,
  time_created timestamp with time zone NOT NULL DEFAULT now(),
  time_updated timestamp with time zone NOT NULL DEFAULT now(),
  inactive_state smallint NOT NULL DEFAULT 0
);


ALTER TABLE public.roles OWNER TO mailtrace;

--
-- TOC entry 1479 (class 1259 OID 54072)
-- Dependencies: 3 1480
-- Name: roles_id_seq; Type: SEQUENCE; Schema: public; Owner: mailtrace
--

CREATE SEQUENCE roles_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.roles_id_seq OWNER TO mailtrace;

--
-- TOC entry 1793 (class 0 OID 0)
-- Dependencies: 1479
-- Name: roles_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: mailtrace
--

ALTER SEQUENCE roles_id_seq OWNED BY roles.id;


--
-- TOC entry 1794 (class 0 OID 0)
-- Dependencies: 1479
-- Name: roles_id_seq; Type: SEQUENCE SET; Schema: public; Owner: mailtrace
--

SELECT pg_catalog.setval('roles_id_seq', 3, true);


--
-- TOC entry 1482 (class 1259 OID 54084)
-- Dependencies: 3
-- Name: rule_ids; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--

CREATE TABLE rule_ids (
    id integer NOT NULL,
    rule_name character varying(50) NOT NULL,
    description text,
    inactive_state smallint NOT NULL DEFAULT 0
);


ALTER TABLE public.rule_ids OWNER TO mailtrace;

--
-- TOC entry 1481 (class 1259 OID 54082)
-- Dependencies: 3 1482
-- Name: rule_ids_id_seq; Type: SEQUENCE; Schema: public; Owner: mailtrace
--

CREATE SEQUENCE rule_ids_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.rule_ids_id_seq OWNER TO mailtrace;

--
-- TOC entry 1795 (class 0 OID 0)
-- Dependencies: 1481
-- Name: rule_ids_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: mailtrace
--

ALTER SEQUENCE rule_ids_id_seq OWNED BY rule_ids.id;


--
-- TOC entry 1796 (class 0 OID 0)
-- Dependencies: 1481
-- Name: rule_ids_id_seq; Type: SEQUENCE SET; Schema: public; Owner: mailtrace
--

SELECT pg_catalog.setval('rule_ids_id_seq', 13, true);