<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : Oct 31, 2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Db/Query/Connects.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/Db/Query/PartitionedAbstract.php';
require_once 'Hmt/Log/ConnectEntry.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since 1.0.9
 */
class Hmt_Db_Query_Connects extends Hmt_Db_Query_PartitionedAbstract {

	/* (non-PHPdoc)
	 * @see Hmt_Db_Query::getSelect()
	 */
	public function getSelect() {
		// TODO Auto-generated method stub
		$select = $this->getNewSelect();
		$select->from(array(
				'c' => $this->getPartitionTable() ));
		if (FALSE === $this->getClause()->isEmpty()) {
			//where clause generieren
			$select->where($this->generateWhere($select));
		}
		return $select;
	}

	/* (non-PHPdoc)
	 * @see Hmt_Db_Query::transformResult()
	 */
	protected function transformResult($row) {
		// TODO Auto-generated method stub
		$row['pt'] = $this->getPartition();
		return new Hmt_Log_ConnectEntry($row);
	}

	/* (non-PHPdoc)
	 * @see Hmt_Db_Query_PartitionedAbstract::getTablePrefix()
	 */
	protected function getTablePrefix() {
		// TODO Auto-generated method stub
		return Hmt_Db_Consts::TABLE_CONNECT;
	}

	/* (non-PHPdoc)
	 * @see Hmt_Db_Query::getTableIDField()
	 */
	protected function getTableIDField() {
		return Hpls_Mailtrace_Consts::SRCH_C_ID;
	}

}