<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : Aug 14, 2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Utils/Logusing.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
abstract class Hmt_Db_Statistics extends Hpls_Utils_Logusing {
	/**
	 * @todo comment
	 * @var Zend_Db_Adapter_Abstract
	 */
	protected $_db = null;

	public function __construct(Zend_Db_Adapter_Abstract $db) {
		$this->_db = $db;
	}

	abstract function getTupleCountsConnect();

	abstract function getTupleCountsDeliver();

	abstract function getDbSize();

	/**
	 * @todo comment
	 * @return string|int|NULL <b>0</b>: noch nie Vacuum ausgeführt<br/>
	 * <b>null</b>: DB Kommunikationsfehler<br/>
	 * sonst: Datumsstring der Form "YYYY-MM-DD hh:mm:ss.nnnnn+TZ"
	 */
	abstract function getLastReorg();

	protected function getConnectTables() {
		return Hpls_Utils::array_values_startWith($this->getTables(), Hmt_Db_Consts::TABLE_CONNECT);
	}

	/**
	 * @todo comment
	 * @return multitype:
	 */
	protected function getTables() {
		$listTables = $this->getDb()->listTables();
		return empty($listTables) ? array() : $listTables;
	}

	/**
	 * @todo comment
	 * @return Zend_Db_Adapter_Abstract
	 */
	protected function getDb() {
		return $this->_db;
	}
}