<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 28.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-05-04 15:02:49 +0200 (Fr, 04. Mai 2012) $
 * last changed by: $LastChangedBy: lazee $
 * revision       : $LastChangedRevision: 9348 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Log/DeliverEntry.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/LogAbstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package HMT
 * @subpackage Datalayer
 * @version $LastChangedRevision: 9348 $
 * @since 1.0.9
 */
class Hmt_Log_DeliverEntry extends Hmt_LogAbstract {
	
	protected static $SHORTEN = array(
			//		"d_status":
			Hmt_Db_Consts::F_D_REASON => 'd_rsn',
			Hmt_Db_Consts::F_D_RELAYHOST => 'd_rh',
			Hmt_Db_Consts::F_D_QUEUE_ID => 'd_qid',
			Hmt_Db_Consts::F_D_SERVER => 'd_srv' );

	//	"c_utime":1301388993214,"pt":"20110328000000","c_id":2,"time":1301347804000,"c_mailfrom":"uriahkinnare@rpa.net","t":"c","tracing_event":"hmt_detailspane_table_event_connect_from"}')
	

	public function setValues($values) {
		//@todo umbennen des primary-keys solang noch das schema nicht ganz richtig ist
		if (isset($values[Hmt_Db_Consts::F_D_ID])) {
			$values['d_id'] = $values[Hmt_Db_Consts::F_D_ID];
			unset($values[Hmt_Db_Consts::F_D_ID]);
		}
		if (isset($values[Hmt_Db_Consts::F_D_TIME])) {
			$values['time'] = $this->toJSdate($values[Hmt_Db_Consts::F_D_TIME]);
			unset($values[Hmt_Db_Consts::F_D_TIME]);
		}
		if (isset($values[Hmt_Db_Consts::F_D_CREATE_TIME])) {
			$values[Hmt_Db_Consts::F_D_CREATE_TIME] = $this->toJSdate($values[Hmt_Db_Consts::F_D_CREATE_TIME]);
		}
		
		if (isset($values[Hmt_Db_Consts::F_D_MAILTO_ADR]) && isset($values[Hmt_Db_Consts::F_D_MAILTO_DOMAIN])) {
			$values[Hmt_Db_Consts::F_D_MAILTO] = $values[Hmt_Db_Consts::F_D_MAILTO_ADR] . '@' . $values[Hmt_Db_Consts::F_D_MAILTO_DOMAIN];
		}
		unset($values[Hmt_Db_Consts::F_D_MAILTO_ADR]);
		unset($values[Hmt_Db_Consts::F_D_MAILTO_DOMAIN]);
		//original_to zusammenfassen, falls es werte hat
		if (isset($values[Hmt_Db_Consts::F_D_ORIGTO_ADR]) && isset($values[Hmt_Db_Consts::F_D_ORIGTO_DOMAIN])) {
			$values[Hmt_Db_Consts::F_D_ORIGTO] = $values[Hmt_Db_Consts::F_D_ORIGTO_ADR] . '@' . $values[Hmt_Db_Consts::F_D_ORIGTO_DOMAIN];
		}
		//orig_to address-teile löschen
		unset($values[Hmt_Db_Consts::F_D_ORIGTO_ADR]);
		unset($values[Hmt_Db_Consts::F_D_ORIGTO_DOMAIN]);
		$values['t'] = 'd';
		
		//@todo mit leben füllen:
		//		$values['tracing_event'] = $values['d_reason'];
		
		parent::setValues($values);
		
		$this->d_srvname = $this->getServerName();
		
		//setzen der connectID triggern
		$this->getConnectID();
	
	}

	public function getConnectID() {
		if (!isset($this->d_cid)) {
			$this->d_cid = $this->pt . 'c' . $this->d_dbid;
		}
		return $this->d_cid;
	}

	public function getDBID() {
		return $this->d_dbid;
	}

	public function getStatus() {
		return $this->d_status;
	}

	public function getRelayHost() {
		return $this->d_rh;
	}

	public function getRelayHostName() {
		return $this->getRelayHost();
	}

	public function getTime() {
		return $this->time;
	}

	public function getQueueID() {
		return $this->d_qid;
	}

	public function getServer() {
		return $this->d_srv;
	}

	public function getServerName() {
		$s = Hmt_Log::i()->getServer($this->getServer());
		if (!empty($s)) {
			return $s->getName();
		}
		return null;
	}

	public function getUpdateTime() {
		return $this->d_utime;
	}

	public function getMailTo() {
		return $this->d_mailto;
	}

	/* (non-PHPdoc)
	 * @see Hmt_LogAbstract::getUniqueKey()
	 */
	public function getUniqueKey() {
		return $this->d_id;
	}

	public function getOriginalReason() {
		return isset($this->d_rsn) ? $this->d_rsn : null;
	}

	public function setShortExplain($text) {
		if ($text === null) {
			//			$this->tracing_event = $this->d_reason;
			unset($this->tevt);
		} else {
			$this->tevt = $text;
		}
	}

	public function setReasonTag($text) {
		if (empty($text)) {
			//			$this->tracing_event = $this->d_reason;
			unset($this->rtag);
		} else {
			$this->rtag = $text;
		}
	}

	static protected function getSaveKey($key) {
		if (array_key_exists($key, self::$SHORTEN)) {
			return self::$SHORTEN[$key];
		}
		return $key;
	}

}