<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 16.11.2011
 * created by     : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-04-15 16:36:08 +0200 (So, 15. Apr 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9311 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Reason/Entry.php $
 *
 * author         : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 */
/**
 */
require_once 'Hmt/Reason/Edit.php';
require_once 'Zend/Json.php';

class Hmt_Reason_Entry {
	public $_confTableName = null;
	public $_confKeys = array();

	/**
	 * Hmt_Reason_Entry in JsonString konvertieren
	 * 
	 * @param $entry Hmt_Reason_Entry
	 */
	public static function toJsonStr(Hmt_Reason_Entry $entry = null) {
		if (FALSE === is_null($entry)) {
			return Zend_Json::encode($entry);
		} else {
			return '';
		}
	
	}

	/**
	 * JsonString in Hmt_Reason_Entry konvertieren.
	 * 
	 * @param $json Json
	 * @return Hmt_Reason_Entry
	 */
	public static function parseJsonStr($json) {
		$entry = new Hmt_Reason_Entry();
		$object = Zend_Json::decode($json);
		foreach ($object as $key => $value) {
			if ($key != '_confTableName') {
				$entry->setValue($key, $value, false);
			} else if (0 !== strpos($key, '_conf')) {
				$entry->setValue($key, $value, false);
			} else {
				$entry->setValue($key, $value);
			}
		}
		return $entry;
	}

	public function __construct() {
	
	}

	public function getKeys() {
		return $this->_confKeys;
	}

	public function getTablename() {
		return $this->_confTableName;
	}

	/**
	 * Parameter auslesen (__get funktioniert nicht so richtig mit der Codierung)
	 * 
	 * @param $key String
	 * @param $base64Decode Boolean
	 */
	public function getValue($key, $base64Decode = true) {
		if (0 === strpos($key, '_') || !$base64Decode) {
			return $this->$key;
		} else {
			return base64_decode($this->$key);
		}
	}

	/**
	 * Parameter setzen (Synonym-Funktion für __set)
	 * 
	 * @param $key String
	 * @param $value String
	 * @param $base64Encode Boolean
	 */
	public function setValue($key, $value, $base64Encode = true) {
		if (0 === strpos($key, '_') || !$base64Encode) {
			$this->$key = $value;
		} else {
			$this->_confKeys[] = $key;
			$this->$key = base64_encode($value);
		}
	}
}