<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 27.12.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-02-22 14:57:33 +0100 (Mi, 22. Feb 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9229 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Reason/Manage.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/**
 */
require_once 'Hmt/Reason.php';

/**
 *
 * @todo comment
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9229 $
 * @since 1.1.0
 */
class Hmt_Reason_Manage extends Hmt_Reason {
	protected static $_instance2 = null;

	/**
	 *
	 * @return Hmt_Reason_Manage
	 */
	public static function i() {
		if (is_null(self::$_instance2)) {
			self::$_instance2 = new self();
		}
		return self::$_instance2;
	}

	/**
	 * Erzeugt die DB-tabellen und erneuert anschließend den Cache.
	 * 
	 * @param $sources array:string|NULL Liste der Sourcen, die angelegt werden. Source-Name
	 *        entspricht den namen in der component.ini.<p>
	 *        wenn NULL, dann werden alle konfigurierten Sourcen genommen.
	 */
	public function createStructure($sources = null) {
		if (is_null($sources)) {
			$sources = $this->getSources();
		} elseif (!is_array($sources)) {
			$sources = array(
					$sources );
		}
		isDebug('hmt_reason_create') && $this->log()->debug(Hpls_Debug::print_r($sources, __METHOD__.' SOURCES '));
		
		foreach ($sources as $source) {
			$this->getDbO($source)->createStructure();
		}
		$this->clearCache();
	}

	/**
	 * Erzeugt die DB-Tabelle, die nötig ist, um Texte für die Sprache $locale
	 * aufzunehmen.
	 * 
	 * @param $locale string|Zend_Locale Die Sprache, die erzeugt werden soll. Format: z.B. 'de_de'
	 * @param $sources array:string|NULL Liste der Sourcen, die angelegt werden. Source-Name
	 *        entspricht den namen in der component.ini.<p>
	 *        wenn NULL, dann werden alle konfigurierten Sourcen genommen.
	 * @throws InvalidArgumentException
	 * @throws Hpls_Mailtrace_Exception_Reason
	 */
	public function createLanguage($locale, $sources = null) {
		if ($locale instanceof Zend_Locale) {
			$locale = $locale->toString();
		}
		if (empty($locale)) {
			throw new InvalidArgumentException('$locale must not be empty', Hpls_Err::ERR_ARGUMENT_EMPTY);
		}
		if (in_array($locale, $this->getAvaiableLanguages())) {
			require_once 'Hpls/Mailtrace/Exception/Reason.php';
			throw new Hpls_Mailtrace_Exception_Reason("Language '$locale' already existist.", Hpls_Mailtrace_Err::ERR_REASON_LANG_EXISTS);
		}
		// create in vendor iff hplsadmin
		// create in customer
		// update cache
	}

}