<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : May 25, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Acl/Consts.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */

/**
 * @todo comment
 * Allgemeine Konstanten für das Hpls_Acl-System.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage Rechtesystem
 * @version $LastChangedRevision: 9196 $
 * @since 1.0ufz
 */
interface Hpls_Acl_Consts {
	/**
	 * 
	 * @var string Nutzer mit dem sich über das Backend am LDAP angemeldet wird.
	 */
	const LDAP_USER = 'sysinit';
	/**
	 * @var string Entsprechendes Passwort zu LDAP_USER
	 */
	const LDAP_PASS = 'IT5aex5J';
	
	/**
	 * @var string Unterverzeichnisname, der für ACL-Konfigurationsdateien vorgesehen ist. Liegt in /var/mailApp/<product>/
	 */
	const APP_ACL_DIR = 'acl';
	/**
	 * @var string Name der DependenciesTree-Definitionsdateien. Sind im APP_ACL_DIR zu finden.
	 */
	const ACL_DEPEND_FILENAME_XML = 'depend.xml';
	const ACL_ACL_FILENAME_POSTFIX_XML = '.acl.xml';
	/**
	 * @var string Name der Zend_Config_Xml-Section, die die DependenciesTree-Informationen enthalten.
	 */
	const ACL_DEPEND_CONFIG_SECTION = 'resourcedependency';
	/**
	 * @var string Name der Zend_Config_Xml-Section, die die DT-Privilege-Informationen enthalten.
	 */
	const ACL_SECTION_PRIVILEGES = 'privileges';
	
	const NS_MASTERSLAVE = 'masterslave_';
	
	/**
	 * @var string Separator innerhalb einer ID, der die Hierarchieebenen trennt.
	 */
	const ID_SEPARATOR = '.';
	/**
	 * @var string Separator zwischen ID und Privilege (max_count, etc.), wenn's innerhalb eines Strings angegeben werden muss.<p>
	 * Bsp: <ID>#<privilege>: ac.services.db#enabled = true
	 * <p>
	 * Wird im LDAP verwendet um Lizenz key-value
	 */
	const ID_VAL_SEPARATOR = '#';
	/**
	 * @var string Trenner für die privileges in einem String, falls mehr als ein Privilege gleichzeitig gelten soll.
	 */
	const ID_VAL_VAL_SEPARATOR = '+';
	
	/**
	 * @var string Separator zwischen 2 IDs.
	 */
	const ID_ID_SEPARATOR = ';';
	/**
	 * @var string Marker für values in der Lizenz, wenn für unterschiedliche Rollen,
	 * unterschiedlice Werte vergegeben werden sollen. Sprich: ein Marker für multivalue, statt single-value.
	 */
	const MULTI_ROLE_MARKER = '#roles#';
}