<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : Jan 25, 2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/Application/Config/Components.php $
 *
 */
/***/
require_once 'Hpls/Application/ConfigAbstract.php';
/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package MailAppCore
 * @subpackage Startup
 * @version $LastChangedRevision: 9196 $
 * @since rc
 */
class Hpls_Application_Config_Components extends Hpls_Application_ConfigAbstract {

	public function init() {
		isDebug('config_plugins_init') && $this->log()->debug("INIT " . __FILE__);
		$config = $this->getConfig();
		Zend_Registry::set(Hpls_Consts::REGK_COMPONENTS, $config);
		return $config;
	}

	protected function getAvaiableCompNames() {
		$components = Hpls_Application::i()->getInstalledHPLSProducts();
		$ret = array();
		$dirs = scandir(APP_CONFIGS_PATH);
		foreach ($components as $file) {
			if (is_dir(APP_CONFIGS_PATH . "/$file") && file_exists(APP_CONFIGS_PATH . "/$file/" . Hpls_Consts0::FILE_CONFIG_COMPONENT)) {
				$ret[$file] = APP_CONFIGS_PATH . "/$file";
				$this->log()->info("INIT Component: Found component '$file'");
			}
		}
		isDebug('config_read') && $this->log()->debug(__METHOD__ . " RESULT: " . Hpls_Debug::print_r($ret, "COMPSCONFIG: "));
		return $ret;
	}

	protected function getConfig() {
		$comps = $this->getAvaiableCompNames();
		//default component must exists -> no config == config error
		if (count($comps) == 0) {
			require_once 'Hpls/Exception/Configuration.php';
			throw new Hpls_Exception_Configuration(Hpls_Exception_Configuration::ERR_DEFAULT_COMP_MIN);
		}
		$ret = array();
		foreach ($comps as $compname => $configDir) {
			$ret[$compname] = $this->readCompConfig($compname, $configDir);
		}
		isDebug('config_read') && $this->log()->debug(__METHOD__ . " RESULT: " . Hpls_Debug::print_r($ret, "COMPSCONFIG: ", false));
		return $ret;
	}

	protected function readCompConfig($compname, $configDir) {
		$filename = Hpls_Application0::i()->getVariableConfigDir($compname) . DIRECTORY_SEPARATOR . Hpls_Consts0::FILE_CONFIG_COMPONENT;
		if (file_exists($filename)) {
			$configIni = new Zend_Config_Ini($filename);
		} else {
			$configIni = new Zend_Config_Ini($configDir . DIRECTORY_SEPARATOR . Hpls_Consts0::FILE_CONFIG_COMPONENT);
		}
		
		$config = $configIni->toArray();
		array_change_key_case($config, CASE_LOWER);
		return array(
				Hpls_Consts::CFG_COMP_CONFIGDIR => $configDir,
				Hpls_Consts::CFG_COMP_CONFIG => $config );
	}
}
