<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 26.05.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Auth/Reader/RolesAbstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hpls_Auth_Reader_Roles_Ini extends Hpls_Auth_Reader_RolesAbstract {
	const OPT_FILE = 'file';
	const OPT_ROLEMAP_FILE = 'rolemapfile';
	const OPT_INI_ROLE_KEY = 'roleskey';
	const OPT_INI_USERNAME_KEY = 'usernamekey';

	/* (non-PHPdoc)
	 * @see Hpls_Acl_Roles_ReaderAbstract::readRoles()
	 */
	function readRoles($username) {
		// TODO Auto-generated method stub
		$this->setUsername($username);
		$roleEntry = Hpls_Utils::array_deep_value($this->getIniFileContents(), $this->_loginMapper->getSubstituted($this->getOption(self::OPT_INI_ROLE_KEY)));
		if (empty($roleEntry)) {
			return array();
		}
		if (!is_array($roleEntry)) {
			$roleEntry = preg_split('/\s*(,|:|\|)\s*/', $roleEntry);
		}
		$this->log()->debug(Hpls_Debug::print_r($roleEntry, __METHOD__));
		
		return $roleEntry;
	}

	public function setOptions(array $options) {
		parent::setOptions($options);
		if (empty($this->_options[self::OPT_FILE])) {
			require_once 'Hpls/Exception/Configuration.php';
			throw new Hpls_Exception_Configuration('In auth.xml for role-source type "ini" in auth-source "' . $this->getSourceName() . '" a "file" is missing.', Hpls_Consts0::ERR_AUTH_INI_NOFILE);
		}
		
		if (empty($this->_options[self::OPT_INI_ROLE_KEY])) {
			$this->_options[self::OPT_INI_ROLE_KEY] = '[[LOGINNAME]]/roles';
		}
	}

	protected function getIniFileContents() {
		$filename = $this->getOption(self::OPT_FILE);
		$cd = stripos($filename, DIRECTORY_SEPARATOR);
		if ($filename instanceof Zend_Config) {
			return $filename->toArray();
		} elseif (is_array($filename)) {
			return $filename;
		} elseif (0 === $cd) {
			$ini = new Zend_Config_Ini($filename);
			return $ini->toArray();
		} else if (false === $cd) { // relativ zu frontend/etc/
			$ini = new Zend_Config_Ini(Hpls_Application0::i()->getVariableConfigDir() . DIRECTORY_SEPARATOR . $filename);
			return $ini->toArray();
		} else {
			//relative file
			require_once 'Hpls/Exception/NotImplemented.php';
			throw new Hpls_Exception_NotImplemented(__METHOD__);
		}
	}
}