<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 11.11.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Utils/Logusing.php';

class Hpls_Configuration_Factory extends Hpls_Utils_Logusing {
	protected static $_instance = null;

	/**
	 * @return Hpls_Configuration_Factory
	 */
	public static function i() {
		if (is_null(self::$_instance)) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}
	
	protected $_services = array();

	protected function __construct() {
	}

	public function registerService($serviceName, Hpls_Configuration_ConfigurationInterface $instance = NULL) {
		if (is_object($serviceName) && $serviceName instanceof Hpls_Configuration_ConfigurationInterface) {
			$refl = new ReflectionClass(get_class($serviceName));
			$this->log()->debug(Hpls_Debug::print_r($refl->getInterfaces()));
		} else {
			$this->_services[$serviceName] = $instance;
		}
	}

	public function getService($serviceName) {
		return isset($this->_services[$serviceName]) ? $this->_services[$serviceName] : null;
	}
}