<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 21.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-02-23 14:29:54 +0100 (Do, 23. Feb 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9237 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Consts0.php $
 *
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
require_once 'Hpls/Err.php';

/**
 *
 * @todo comment
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9237 $
 * @since
 *
 */
interface Hpls_Consts0 extends 
	Hpls_Err {
	/* Für die Erkennung in welcher Application wir uns befinden
	 * siehe Hpls_Application::getApplicationType()
	 */
	const APP_MAILAPP_FRONTEND = 'appFrontend';
	const APP_MAILAPP_BACKEND = 'appFrontend';
	const APP_MAILTRACE_FRONTEND = 'hmtFrontend';
	const APP_MAILAPP_CLI = 'appCli';
	
	/* Zend_Registry keys */
	const REGK_APPLICATION = 'application';
	
	/**
	 *
	 * @var unknown_type
	 */
	const REGK_COMPONENTS = 'hpls_components';
	const REGK_ACLS = 'hpls_acls';
	/**
	 * Inhalt von auth.xml
	 * 
	 * @var unknown_type
	 */
	const REGK_AUTH = 'hpls_auth';
	/**
	 *
	 * @todo comment
	 *       Key für Zend_Registry, um die application.ini zu erhalten.
	 *       Typ des Registry-Eintrags ist ein Array
	 * @var string
	 */
	const REGK_CONFIG = 'hpls_config';
	const REGK_LOGGER = 'hpls_globallogger';
	const REGK_LOGGERCONF = 'hpls_loggerconf';
	const REGK_LOCALE = 'Zend_Locale';
	const REGK_I18N = 'Zend_Translate';
	const REGK_LICENSE = 'hpls_license';
	const REGK_SESSION = 'hpls_session';
	const REGK_UNIFICATION_CONFIG = 'hpls_unifier';
	const REGK_VALIDATION_CONFIG = 'hpls_validation';
	const REGK_POLICY_CONFIG = 'hpls_policies';
	const REGK_SOAP_SERVICES = 'hpls_soap_services';
	const REGK_PERSISTENCE = 'hpls_persistence';
	
	const REGK_DEBUG = '~~debugConf~~';
	const REGK_MAINTENANCE = 'hpls_maintenance';
	
	// Validation & Unifikation & Policy
	const CFG_GLOBAL_VALIDATION_ON = 'validation';
	const CFG_GLOBAL_UNIFICATION_ON = 'unification';
	const CFG_GLOBAL_POLICYCHECK_ON = 'policycheck';
	
	const CFG_I18N = 'i18n';
	const CFG_I18N_LANG = 'lang';
	const CFG_I18N_ADAPTER = 'adapter';
	const CFG_I18N_PATH = 'path';
	const CFG_I18N_EXT = 'extension';
	
	const OPT_LOGINMAPPING = 'loginmapping';
	const OPT_USERNAME = 'username';
	const OPT_PASSWORD = 'password';
	
	const DATE_FORMAT = 'j.m.Y H:i:s';
	const DATE_FORMAT_JS = 'D, d M Y H:i:s \G\M\TO';
	
	const MENU_CONFIG_NAME_POSTFIX = '.menu.xml';
	const DIR_DATA_JOBS = '/opt/heinlein-elements/appliance/backend/data/jobs';
	const FILE_CONFIG_COMPONENT = 'component.ini';
	const FILE_CONFIG_APPLICATION = 'application.ini';
	const FILE_CONFIG_AUTH = 'auth.xml';
	
	/* keys in request object params */
	
	const REQ_MSGS = '__messages__';
	
	/**
	 * Zend_Auth_Storage_Session::NAMESPACE_DEFAULT
	 * 
	 * @var unknown_type
	 */
	const SESNS_AUTH = 'Zend_Auth';
	const SESSION_NS_AUTH = 'AC2_auth';
	/**
	 * Session-Namespace für persistierte Meldungen
	 * 
	 * @var string
	 */
	const SESSION_NS_MSGS = 'hpls_msgs';
	const SESSION_NS_NAVI = 'hpls_nav';
	
	const DB_TYPE_MYSQL = 'mysql';
	const DB_TYPE_PGSQL = 'pgsql';
	const DB_TYPE_SQLITE = 'sqlite';
	
	const SQL_VAR_LOCALE = '[[LOCALE]]';
	const SQL_VAR_DBKEY = '[[DBKEYNAME]]';
	const SQL_VAR_TABLEPREFIX = '[[TABLEPREFIX]]';
	const SQL_VAR_OWNER = '[[OWNER]]';
	
	/* standard keys für die 'config'-tabellen einer datenbank */ 
	const SQL_CONFIGKEY_VERSION = 'version';
	
	const AUTH_VAR_USERNAME = 'USERNAME';
	const AUTH_VAR_PASSWORD = 'PASSWORD';
	/**
	 * Variablenname für den LoginMapper, der den LOGINnamen repräsentiert.
	 * 
	 * @var unknown_type
	 */
	const AUTH_VAR_LOGIN = 'LOGIN';
	
	const AUTH_CRYPTMETHOD_MD5 = 'md5';
	const AUTH_CRYPTMETHOD_PLAIN = 'plain';
	
	const ROLE_GUEST = 'guest';
	const ROLE_USER = 'user';
	const ROLE_MAILUSER = 'mailuser';
	const ROLE_HELPDESK = 'helpdesk';
	const ROLE_POSTMASTER = 'postmaster';
	const ROLE_SUPER_POSTMASTER = 'superpostmaster';
	const ROLE_ADMIN = 'admin';
	const ROLE_SUPERADMIN = 'superadmin';
	const ROLE_HPLSADMIN = 'hplsadmin';
	const ROLE_LOGGEDIN = 'loggedin';
	
	const CACHE_TAG_ACL = 'acl';
	const CACHE_TAG_AUTH = 'auth';
	
	/**
	 * RegEx für Begin-Marker in Textdateien, die als SQL verarbeitet werden sollen
	 * 
	 * @var string
	 */
	const MARKER_PHPSQL_BEGIN = '/\n\s*--\s*PHPSQL-BEGIN(\s.*)?\n\s*/';
	/**
	 * RegEx für Ende-Marker in Textdateien, die als SQL verarbeitet werden sollen
	 * 
	 * @var string
	 */
	const MARKER_PHPSQL_END = '/\n\s*--\s*PHPSQL-END(\s.*)?\n\s*/';

}