<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 27, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/Controller/Plugin/Debug.php $
 *
 */
/**
 *
 */
require_once 'Hpls/Controller/Plugin/Abstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since 
 */
class Hpls_Controller_Plugin_Debug extends Hpls_Controller_Plugin_Abstract {

	function preDispatch(Zend_Controller_Request_Abstract $request) {
		$this->getLogger()->debug(__METHOD__ . ": M: " . $request->getModuleName() . " C: " . $request->getControllerName() . " A: " . $request->getActionName());
		isDebug('log_request') && $this->log()->info(Hpls_Debug::print_r($request, __METHOD__ . ' REQUEST '));
		//$this->log()->debug(Hpls_Debug::print_r(Hpls_Acl::i(),__METHOD__));
	}

	function postDispatch(Zend_Controller_Request_Abstract $request) {
		if (isDebug()) {
			$viewerRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('ViewRenderer');
			isDebug('trace_plugins') && $this->getLogger()->debug(__METHOD__ . "  Getting view for debug display");
			$view = $viewerRenderer->view;
			if (isDebug('session') && isset($_SESSION)) {
				isDebug('view_debug_on_html') && $view->assign('sessionData', Hpls_Debug::print_r($_SESSION));
			}
			isDebug('trace_plugins') && $this->getLogger()->debug(__METHOD__ . "  DONE debug print");
			$sess = Hpls_Application::i()->getSession(Hpls_Consts::SESSION_NS_AUTH);
		}
	}

	function dispatchLoopShutdown() {
		isDebug('hpls_msgs') && $this->log()->debug(Hpls_Debug::print_r(Hpls_Msgs::i(),__METHOD__));
		isDebug('log_response') && $this->log()->info(Hpls_Debug::print_r($this->getResponse(), __METHOD__ . ' RESPONSE '));
		isDebug('session') && isset($_SESSION) && $this->getLogger()->debug(__METHOD__ . '## session data: ' . Hpls_Debug::print_r($_SESSION));
	}
}