<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 24.08.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Controller/Plugin/Abstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hpls_Controller_Plugin_Maintenance extends Hpls_Controller_Plugin_Abstract {

	public function dispatchLoopStartup(Zend_Controller_Request_Abstract $request) {
		$this->log()->info(__METHOD__);
		$offline = false;
		$msg = '';
		try {
			//lokal hat vorrang vor global
			$cfgLocal = Hpls_Settings::i()->getConfig('ac.maintenance.local');
			if (is_null($cfgLocal) || !$cfgLocal->offline) {
				try {
					$cfgGlobal = Hpls_Settings::i()->getConfig('ac.maintenance.global');
					if (!is_null($cfgGlobal)) {
						
						$offline = Hpls_Utils::toBool($cfgGlobal->offline);
						$msg = $cfgGlobal->message;
					} else {
						$offline = false;
						$msg = '';
					
					}
				} catch (Exception $ex1) {
					//bei einer Exception machen wir erst einmal nichts, es könnte sein,dass die DB nicht erreichbar ist
				}
			} else {
				//wir sind offline
				$offline = true;
				$msg = is_null($cfgLocal) ? '' : $cfgLocal->message;
			}
		} catch (Exception $ex) {
		
		}
		
		if ($offline) {
			$this->log()->warn(__METHOD__ . " Maintenance mode is active");
			//@todo irgendwo hin umleiten
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_WARN, 'maintenance', $msg);
			
			if (Hpls_Auth::i()->isLoggedIn() && !hasRole(Hpls_Consts0::ROLE_HELPDESK)) {
				$redirect = new Zend_Controller_Action_Helper_Redirector();
				$redirect->gotoSimpleAndExit('maintenance', 'logout', 'auth');
				return ;		
			}
		}
	}
}