<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 18.10.2010
 * created by     : author
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Controller/Plugin/Navigation.php $
 * 
 * author         : author
 */
/***/
require_once 'Hpls/Controller/Plugin/Abstract.php';
require_once 'Hpls/View/Smarty.php';
require_once 'Hpls/View/Consts0.php';
require_once 'Hpls/Acl.php';
require_once 'Hpls/Navigation.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package HPLS
 * @subpackage subpackage
 * @version $LastChangedRevision: 9196 $
 * @since beta
 *
 */
class Hpls_Controller_Plugin_Navigation extends Hpls_Controller_Plugin_Abstract {

	public function postDispatch(Zend_Controller_Request_Abstract &$request) {
		$view = $this->getView();
		$menu = array();
		
		$menu[Hpls_View_Consts0::MENU_TOP] = $this->getTopMenu(); //$this->generateTopMenu();
		$menu[Hpls_View_Consts0::MENU_LEFT] = Hpls_Navigation::i()->getActiveTab();
		
		$menu['top2'] = $this->getTopMenu();
		
		$view->assign(Hpls_View_Consts0::MENU, $menu);
		$appConfig = Hpls_Application::i()->getConfig('product');
		
		$view->assign(Hpls_View_Consts0::V_APPLICATION_NAME, isset($appConfig['name']) ? $appConfig['name'] : 'Heinlein Elements');
	}

	protected function getBaseUrl() {
		return $this->getRequest()->getBaseUrl();
	}

	protected function getTopMenu() {
		$tabIDs = Hpls_Navigation::i()->getNavTree();
		$ret = array();
		foreach ($tabIDs as $tabID) {
			$ret[$tabID->getId()] = $tabID;
		}
		return $ret;
	}

	protected function getSideMenu() {
		$curTab = Hpls_Navigation::i()->getActiveTab();
	
	}

	protected function getView() {
		isDebug('trace_plugins', 'navigation') && $this->getLogger()->debug(__METHOD__ . " Getting viewrenderer");
		
		/* @var Zend_Controller_Action_Helper_ViewRenderer */
		$viewerRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('ViewRenderer');
		//		$this->getLogger()->debug(Zend_Debug::dump($viewerRenderer,"viewerRenderer",false));
		isDebug('trace_plugins', 'navigation') && $this->getLogger()->debug(__METHOD__ . " Getting view");
		/* @var Hpls_View_Smarty */
		return $viewerRenderer->view;
	}
}