<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : Jan 26, 2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Debug.php $
 *
 */
/***/
require_once 'Zend/Debug.php';
require_once 'Zend/Registry.php';
require_once 'Hpls/Utils.php';
require_once 'Hpls/Exception/NotImplemented.php'; //damit's nirgendswo explizit includiert werden muss


defined('REGBCK_DEBUG') || define('REGBCK_DEBUG', '~~debugConf~~');

if (!function_exists('isDebug')) {

	function isDebug(/* $key = 'debug_on' */) {
		if (!Zend_Registry::isRegistered(REGBCK_DEBUG)) {
			return false;
		}
		
		$debugConf = Zend_Registry::get(REGBCK_DEBUG);
		$args = func_get_args();
		array_unshift($args, 'debug_on');
		foreach ($args as $key) {
			if (!isset($debugConf[$key]) || FALSE == Hpls_Utils::toBool($debugConf[$key])) {
				return false;
			}
		}
		//	Zend_Registry::get(Hpls_Consts::REGK_LOGGER)->debug(__FUNCTION__.": ".print_r($debugConf,true));
		return true;
	}
}

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage Hilfsklassen
 * @version $LastChangedRevision: 9196 $
 * @since Magdeburg:Produktiv1
 */
class Hpls_Debug extends Zend_Debug {

	public static function print_r($var, $label = 'PRINT_R:VALUES', $echo = false) {
		if ($echo) {
			echo "$label >>>\n" . print_r($var, true) . "\n<<<";
		} else {
			return "$label >>>\n" . print_r($var, true) . "\n<<<";
		}
	}

	public static function dump($var, $label = null, $echo = false) {
		return parent::dump($var, $label, $echo);
	}

	public static function dump2str(&$var) {
		return var_export($var, true);
	}

	/**
	 * @return Zend_Log
	 */
	public static function log() {
		return Hpls_Utils::log();
	}

}
