<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 26, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/I18n/Utils.php $
 *
 */
/***/
require_once 'Hpls/Var/Parser.php';

/**
 * Hilfsklasse zum Umgang mit den Internationalisierungen.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since alpha
 */
class Hpls_I18n_Utils {
	/**
	 * Enter description here ...
	 * @var Zend_Translate
	 */
	protected static $_trans = NULL;

	/**
	 * @todo comment
	 *
	 * @return Zend_Translate
	 */
	public static function getZendTrans() {
		if (self::$_trans === NULL) {
			self::$_trans = Hpls_Utils::getI18N();
		}
		return self::$_trans;
	}

	/**
	 * @todo comment
	 *
	 * @param string $messageID a text that should be translated, normally a id and not a real text.
	 * @return string
	 */
	public static function translate($messageID) {
		return self::getZendTrans()->translate($messageID);
	}

	/**
	 * @todo comment
	 *
	 * @param string $messageID
	 * @param array $replaces
	 * @return string
	 */
	public static function translateReplace($messageID, array $replaces, $ignoreVarNameCase = false) {
		$text = self::getZendTrans()->translate($messageID);
		$parser = Hpls_Var_Parser::getInstance();
		$parser->setIgnoreCase($ignoreVarNameCase);
		$parser->parse($text);
		$parser->setValues($replaces);
		
		return $parser->getReplaced();
	}

	/**
	 * Gibt alle definierten Übersetzungspaare als Array zurück.
	 * @return array:string:string
	 */
	public static function getMessages() {
		return self::getZendTrans()->getAdapter()->getMessages();
	}
}