<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 19.12.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 *
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage Job-Queue
 * @version $LastChangedRevision$
 * @since 1.0.7
 */
class Hpls_Job_Status_Factory {
	protected static $_instance = null;

	/**
	 * @return Hpls_Job_Status_Factory
	 */
	public static function i() {
		if (is_null(self::$_instance)) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	protected function __construct() {
	}

	/**
	 * Enter description here ...
	 * @param unknown_type $jobName
	 * @param unknown_type $jobID
	 * @param unknown_type $jobHost
	 * @return Hpls_Job_StatusAbstract|null
	 */
	public function getStatus($jobName, $jobID, $jobHost = 'localhost') {
		$app = Hpls_Application::i()->getApplicationType();
		switch ($app) {
			case Hpls_Consts0::APP_MAILAPP_FRONTEND :
			// später, wenn's funktioniert:
			//				require_once 'Hpls/Job/Status/Backend.php';
			//				return new Hpls_Job_Status_Backend($jobName, $jobID, $jobHost);
			case Hpls_Consts0::APP_MAILAPP_BACKEND :
			case Hpls_Consts0::APP_MAILAPP_CLI :
				require_once 'Hpls/Job/Status/File.php';
				return new Hpls_Job_Status_File($jobName, $jobID, $jobHost);
			case Hpls_Consts0::APP_MAILTRACE_FRONTEND :
				require_once 'Hpls/Job/Status/File.php';
				return new Hpls_Job_Status_File($jobName, $jobID, $jobHost);
		}
		
		return null;
	}
}