<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 15.10.2010
 * created by     : author
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Log.php $
 *
 * author         : author
 */
/***/
require_once 'Zend/Log.php';
require_once 'Hpls/Utils.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since 1.0.5
 */
class Hpls_Log extends Zend_Log {
	protected $_reqid = '';

	/**
	 * @return Zend_Log
	 */
	public static function i() {
		return Hpls_Utils::log();
	}

	static public function factory($config = array()) {
		if ($config instanceof Zend_Config) {
			$config = $config->toArray();
		}
		
		if (!is_array($config) || empty($config)) {
			/** @see Zend_Log_Exception */
			require_once 'Zend/Log/Exception.php';
			throw new Zend_Log_Exception('Configuration must be an array or instance of Zend_Config');
		}
		
		$log = new self();
		
		if (!is_array(current($config))) {
			$log->addWriter(current($config));
		} else {
			foreach ($config as $writer) {
				$log->addWriter($writer);
			}
		}
		
		return $log;
	}

	public function log($message, $priority, $extras = null) {
		parent::log($this->_reqid . $message, $priority, $extras);
	}

	public function setRequestID($id) {
		$this->_reqid = "#RID:$id# ";
	}

}