<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Feb 1, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2010-10-14 12:39:09 +0200 (Do, 14. Okt 2010) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 7268 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hpls/Mailtrace/Model/Entry/LogEntry.php $
 *
 */
/**
 *
 */
require_once 'Hpls/Model/Abstract.php';
require_once 'Hpls/Mailtrace/Model/Entry/DeliverInterface.php';
require_once 'Hpls/Mailtrace/Model/Entry/ConnectInterface.php';
/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package Mailtrace
 * @subpackage Model
 * @version $LastChangedRevision: 7268 $
 * @since beta
 *
 */
class Mailtrace_Model_LogEntry extends Hpls_Model_Abstract implements 
Hpls_Mailtrace_Model_Entry_DeliverInterface, Hpls_Mailtrace_Model_Entry_ConnectInterface
{
	const REASON_SHORT = 'reasonShort';
	public static $ALLOWED_ATTRS = array(self::ATTR_D_ID, self::ATTR_D_REF_C_ID, 
	self::ATTR_D_MAILTO, self::ATTR_D_QUEUE_ID, self::ATTR_D_REASON, self::ATTR_D_RELAYHOST, 
	self::ATTR_D_STATUS, self::ATTR_D_TIME, self::ATTR_C_CLIENT, self::ATTR_C_ID, 
	self::ATTR_C_MAILFROM, self::ATTR_C_MSG_ID, self::ATTR_C_MXNAME, self::ATTR_C_QUEUE_ID, 
	self::ATTR_C_SIZE, self::ATTR_C_TIME, self::REASON_SHORT);
	
	protected $explainReasonUrl = null;
	protected $_detailsUrl = null;

	public function __get($varName) {
		return parent::__get($varName);
	}

	public function __set($varName, $value) {
		parent::__set($varName, $value);
	}

	public function __construct() {
		parent::__construct(self::$ALLOWED_ATTRS);
	}

	public function getClient() {
		return $this->__get(self::ATTR_C_CLIENT);
	}

	public function getFrom() {
		return $this->__get(self::ATTR_C_MAILFROM);
	}

	public function getRelayHost() {
		return $this->__get(self::ATTR_D_RELAYHOST);
	}

	public function getC_ID() {
		return $this->__get(self::ATTR_C_ID);
	}

	public function getD_ID() {
		return $this->__get(self::ATTR_D_ID);
	}

	public function getMailTo() {
		return $this->__get(self::ATTR_D_MAILTO);
	}

	public function getConnectQueueID() {
		return $this->__get(self::ATTR_C_QUEUE_ID);
	}

	public function getDeliverQueueID() {
		return $this->__get(self::ATTR_D_QUEUE_ID);
	}

	public function getReason() {
		return $this->__get(self::ATTR_D_REASON);
	}

	public function getMailFrom() {
		return $this->__get(self::ATTR_C_MAILFROM);
	}

	public function getMessageID() {
		return $this->__get(self::ATTR_C_MSG_ID);
	}

	public function getMxName() {
		return $this->getC_Server();
	}
	
	public function getC_Server() {
		return $this->__get(self::ATTR_C_MXNAME);
	}
	
	public function getD_Server() {
		return $this->__get(self::ATTR_D_SERVER);
	}

	public function getConnectTime() {
		return $this->__get(self::ATTR_C_TIME);
	}

	public function getDeliverTime() {
		return $this->__get(self::ATTR_D_TIME);
	}

	public function getSize() {
		return $this->__get(self::ATTR_C_SIZE);
	}

	public function getStatus() {
		return $this->__get(self::ATTR_D_STATUS);
	}

	public function getReasonShort() {
		return $this->__get(self::REASON_SHORT);
	}

	public function hasReasonShort() {
		return !empty($this->{self::REASON_SHORT});
	}
	
	public function isDelivered() {
		return !empty($this->{self::ATTR_D_QUEUE_ID});
	}

	public function setReasonShort($text) {
		$this->reasonShort = $text;
	}
	
	public function setExplainUrl($url) {
		$this->explainReasonUrl = $url;
	}
	public function getExplainUrl() {
		return $this->explainReasonUrl; 
	}
	
	public function setDetailsUrl($url) {
		$this->_detailsUrl = $url;
	}
	public function getDetailsUrl() {
		return $this->_detailsUrl;
	}
	
	/**
	 * @todo implement
	 * @return string
	 */
	public function getDifference() {
		return '+++TODO+++';
	}

	public function merge(Mailtrace_Model_LogEntry &$other) {
		$this->_attributes = array_merge($this->_attributes, $other->_attributes);
	}
}
