<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 28.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
class Hpls_Mailtrace_ModelAbstract {
	protected $_attributes = null;

	public function __get($varName) {
		if (isset($this->_attributes[$varName])) {
			return $this->_attributes;
		} else {
			return NULL;
		}
	}

	public function __set($varName, $value) {
		$this->_attributes[$varName] = $value;
	}

	public function __isset($varName) {
		return isset($this->_attributes[$varName]);
	}

	/**
	 * @todo comment
	 * @todo think over: currently it prevents setting the variable again, if restrictions is on
	 * @param unknown_type $varName
	 */
	public function __unset($varName) {
		if (isset($this->_attributes[$varName])) {
			unset($this->_attributes[$varName]);
		}
	}

	final protected function get($varName) {
		return $this->__get($varName);
	}

	final protected function set($varName, $value) {
		$this->_attributes[$varName] = $value;
	}

	public function setValues(array $values) {
		if (is_null($values)) {
			$this->_attributes = array();
			return;
		}
		
		foreach ($values as $key => $value) {
			$this->__set($key, $value);
		}
	}

}