<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 23.08.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Settings/Maintenance.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
class Hpls_Settings_Maintenance extends Hpls_SettingsAbstract {

	protected $cfg = null;
	public function __construct($parent, $key = 'maintenance') {
		parent::__construct($parent, null, $key);
		$this->cfg = Hpls_Application::i()->getComponentConfig('AC');
	}
	
	public function isLocalOffline() {
		return Hpls_Utils::toBool(isset($this->cfg['maintenance']['local']['offline'])?$this->cfg['maintenance']['local']['offline']:false);
	}
	
	public function isGlobalOffline() {
		return Hpls_Utils::toBool(isset($this->cfg['maintenance']['global']['offline'])?$this->cfg['maintenance']['global']['offline']:false);
	}
	
	public function getLocalText() {
		return $this->cfg['maintenance']['local']['text'];
	}
	public function getGlobalText() {
		return $this->cfg['maintenance']['global']['text'];
	}
}