<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 20, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/Helper.php $
 *
 */
/**
 *
 */
#require_once 'Smarty/'


class My_Smarty_Plugin_Handler {

	/**
	 * Wywołanie pluginu
	 *
	 * @param string $name nazwa pluginu
	 * @param array $args $args[0] = tablica atrybutów
	 * @return bool czy udało się wywołać plugin
	 */
	public function __call($name, $args) {
		if ($this->loadSmartyPlugin($name, $args[1])) {
			$plugin = $this->smarty->registered_plugins[$name][1];
			$pluginClass = get_class($plugin[0]);
			if (strncmp($pluginClass, 'My_', 3) || strncmp($pluginClass, 'Zend_', 5)) {
				try {
					if (isset($args[0][0]['_method'])) {
						$plugin[1] = $args[0][0]['_method'];
						unset($args[0][0]['_method']);
					}
					return call_user_func_array($plugin, $args[0][0]);
				} catch (Exception $e) {
					return false;
				}
			}
		}
		return parent::__call($name, $args);
	}

	/**
	 * Ładowanie helperów Zend Framework
	 *
	 * @param string $name nazwa helpera
	 * @param array $plugin_type typ pluginu
	 * @param Smarty_Internal_Plugin_Handler $smarty_plugin_handler
	 * @return bool czy ładowanie przebiegło pomyślnie
	 */
	public static function loadZendPlugin($name, $plugin_type, $smarty_plugin_handler) {
		try {
			$smarty_plugin_handler->smarty->registered_plugins[$name] = array(
					'function',
					array(
							$smarty_plugin_handler->smarty->getZendView()->getHelper($name),
							$name ),
					true );
		} catch (Zend_Loader_PluginLoader_Exception $e) {
			// Nie znaleziono helpera
			return false;
		}
		return true;
	}
}