<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 28, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/block.group.php $
 *
 */
/**
 *
 */
require_once 'Hpls/View/Consts.php';
require_once 'Hpls/Utils.php';
require_once 'Hpls/I18n/Utils.php';

function smarty_block_group(array $params, $content, Smarty_Internal_Template &$smarty, &$repeat) {
	if ($repeat) {
		return;
	}
	
	if (!empty($params['title'])) {
		$title = $params['title'];
		if (empty($params['noI18N']) || $params['noI18N'] != FALSE) {
			$title = Hpls_I18n_Utils::translate($title);
		}
		if (!empty($params['allowHtml']) && $params['allowHtml'] != TRUE) {
			require_once 'Smarty/plugins/modifier_strip_tags.php';
			$title = smarty_modifier_strip_tags($title, FALSE);
		}
		$smarty->assign('groupTitle', $title);
	} else
		$smarty->clearAssign('groupTitel');
	
	if (!empty($params['id'])) {
		$smarty->assign('group_id', $params['id']);
	}
	if (!empty($params['description'])) {
		$smarty->assign('group_description', $params['description']);
	}
	
	$smarty->assign('groupContent', $content);
	
	$ret = $smarty->fetch('_frame/group.tpl');
	$smarty->clearAssign('groupContent');
	$smarty->clearAssign('groupTitel');
	
	return $ret;
}