<?php

/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 29.06.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Msgs.php';

/**
 * @todo comment
 * @param array $params
 * @param unknown_type $content
 * @param Smarty_Internal_Template $tplObj
 * @param unknown_type $repeat
 * @return void|string
 */
function smarty_function_renderMsg(array $params, $content, Smarty_Internal_Template &$tplObj, &$repeat) {
	if ($repeat)
		return;
	
	$ret = '';
	$style = 'ul';
	$showCategory = false;
	if (!empty($params['style'])) {
		$style = (string) $params['style'];
	}
	if (!empty($params['showCategory'])) {
		$showCategory = (string) $params['showCategory'];
	}
	
	if (!empty($params['field'])) {
		//field msg
		if (Hpls_Msgs::i()->hasFieldMsg($params['field'])) {
			$tplData = new Smarty_Data($tplObj);
			$tplData->assign('messages', Hpls_Msgs::i()->getFieldMsgs($params['field']));
			$tplData->assign('showCategory', $showCategory);
			$tplData->assign('field', $params['field']);
			$tplData->assign('content', $content);
			$ret .= $tplObj->fetch("_msgs/$style/field_frame.tpl", null, null, $tplData);
		}
	} elseif (!empty($params['group'])) {
		//sektion message
	} elseif (Hpls_Msgs::i()->hasGlobalMsg()) {
		//globale message
		$tplData = new Smarty_Data($tplObj);
		$tplData->assign('messages', Hpls_Msgs::i()->getGlobalMsgs());
		$tplData->assign('showCategory', $showCategory);
		$tplData->assign('content', $content);
		$ret .= $tplObj->fetch("_msgs/$style/global_frame.tpl", null, null, $tplData);
	}
	
	return $ret;
}