<?php

/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 23.08.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Utils/Logusing.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Zend/Log.php';
require_once 'Zend/Registry.php';

/**
 * Basis-Klasse für Klassen, die einen Zend_Logger verwenden wollen und einen möglichen vorhandenen zentralen Logger automatisch weiterverwenden wollen.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since 1.0.2.6
 */
abstract class Hpls_Utils_Logusing {
	private $_logger = null;
	private $_tmpLogger = null;
	protected $DEBUG = FALSE;
	
	private static $_staticLogger = null;

	/**
	 * Enter description here ...
	 * Benötigt im CLI-Framework Hpls_Cli_*
	 * @return NULL
	 */
	static protected function slog() {
		if (is_null(self::$_staticLogger)) {
			if (Zend_Registry::isRegistered(Hpls_Consts0::REGK_LOGGER)) {
				$logger = Zend_Registry::get(Hpls_Consts0::REGK_LOGGER);
			} else if ($this->DEBUG === TRUE) {
				require_once 'Zend/Log/Writer/Stream.php';
				$writer = new Zend_Log_Writer_Stream('php://output');
				$logger = new Zend_Log($writer);
			} else {
				require_once 'Zend/Log/Writer/Null.php';
				$writer = new Zend_Log_Writer_Null();
				$logger = new Zend_Log($writer);
			}
			self::$_staticLogger = $logger;
		}
		
		return self::$_staticLogger;
	}

	public function setLogger(Zend_Log $logger) {
		$this->_logger = $logger;
	}

	/**
	 * Gibt die Log-Instance zurück mit der geloggt wird.
	 * 
	 * @return Zend_Log
	 */
	protected function log() {
		if (is_null($this->_logger)) {
			if (Zend_Registry::isRegistered(Hpls_Consts0::REGK_LOGGER)) {
				$logger = Zend_Registry::get(Hpls_Consts0::REGK_LOGGER);
			} else {
				if (is_null($this->_tmpLogger)) {
					if ($this->DEBUG) {
						require_once 'Zend/Log/Writer/Stream.php';
						$writer = new Zend_Log_Writer_Stream('php://output');
						$logger = new Zend_Log($writer);
					} else {
						require_once 'Zend/Log/Writer/Null.php';
						$writer = new Zend_Log_Writer_Null();
						$logger = new Zend_Log($writer);
					}
					$this->_tmpLogger = $logger;
				}
				return $this->_tmpLogger;
			}
			$this->_logger = $logger;
		}
		
		return $this->_logger;
	}

}
