--
-- Copyright (c) Heinlein Professional Linux Support GmbH
--
-- created   : 06.09.2010
-- created by: Christoph Graupner <c.graupner@heinlein-support.de>
--
-- last changed   : $LastChangedDate: 2012-02-22 15:00:47 +0100 (Mi, 22. Feb 2012) $
-- last changed by: $LastChangedBy: cgr $
-- revision       : $LastChangedRevision: 9231 $
-- 
-- author         : Christoph Graupner <c.graupner@heinlein-support.de>
--

--
-- Tabellenstruktur für Tabelle `config`
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

CREATE TABLE IF NOT EXISTS `[[TABLEPREFIX]]config` (
  `key` varchar(250) NOT NULL,
  `value` text,
  `time_created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `regexrule`
--

CREATE TABLE IF NOT EXISTS `[[TABLEPREFIX]]regexrule` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_t` varchar(1) NOT NULL DEFAULT '[[DBKEYNAME]]',
  `regex` varchar(1024) NOT NULL,
  `rule_id` int(11) NOT NULL,
  `rule_id_t` varchar(1) NOT NULL DEFAULT '[[DBKEYNAME]]',
  `deactivated` tinyint(4) NOT NULL,
  `description` text,
  `param_map` varchar(512) NOT NULL,
  `priority` int(11) NOT NULL DEFAULT '0',
  `time_created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `inactive_state` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`id_t`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `roles`
--

CREATE TABLE IF NOT EXISTS `[[TABLEPREFIX]]roles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_t` varchar(1) NOT NULL DEFAULT '[[DBKEYNAME]]',
  `role_name` varchar(50) NOT NULL,
  `time_created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `inactive_state` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`id_t`),
  UNIQUE KEY `unique_[[TABLEPREFIX]]role_name` (`role_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur für Tabelle `rule_ids`
--

CREATE TABLE IF NOT EXISTS `[[TABLEPREFIX]]rule_ids` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_t` varchar(1) NOT NULL DEFAULT '[[DBKEYNAME]]',
  `rule_name` varchar(50) NOT NULL,
  `description` text NOT NULL,
  `time_created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `time_updated` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `inactive_state` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`id_t`),
  UNIQUE KEY `unique_[[TABLEPREFIX]]rule_name` (`rule_name`),
  UNIQUE KEY `unique_[[TABLEPREFIX]]rule_ids_id_t` (`id`,`id_t`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!



